<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.17 $
 * $Author: tora60 $
 * $Date: 2008/11/09 12:25:34 $
 */

defined('mxMainFileLoaded') or die('access denied');

switch ($_REQUEST['op']) {
    /**
     */
    case 'setup';
        $option = _STEP_DBSETTINGS;
        // check, ob die Datei mit der Grundkonfiguration vorhanden ist
        if (!@file_exists(FILE_CONFIG_BASE) || !is_readable(FILE_CONFIG_BASE)) {
            $output = '
            	<p>' . _THEREERROR . '</p>
            	<ul>
            		<li>&quot;<em>' . FILE_CONFIG_BASE . '</em>&quot; ' . _FILE_NOT_FOUND . '</li>
            	</ul>
        			<form action="index.php" method="post" class="inline">
        				<p>' . hiddenrequest($_REQUEST['lastop']) . '
        					<input type="submit" value="' . _GOBACK . '" />
        				</p>
        			</form>
        			<form action="index.php" method="post" class="inline">
        				<p>' . hiddenrequest('setup') . '
        					<input type="submit" value="' . _REMAKE . '" />
        				</p>
        			</form>';
        } else {
            if (isset($_REQUEST['dbhost']) && isset($_REQUEST['dbname']) && isset($_REQUEST['dbuname']) && isset($_REQUEST['dbpass']) && isset($_REQUEST['prefix']) && isset($_REQUEST['user_prefix'])) {
                $set = $_REQUEST;
            } else {
                $set = setupFormDefaults();
            }
            $output = '
            	<form action="index.php" method="post">
        				<p>' . hiddenrequest('checkdb') . '</p>
        				' . dbsettings($set) . '
        				<p><input type="submit" value="' . _SUBMIT . '" /></p>
        			</form>';
        }
        break;
    /**
     */
    case 'checkdb';
        $err = '';
        $dbnotexist = false;
        $set = setupFormDefaults();
        $_REQUEST['dbhost'] = (empty($_REQUEST['dbhost'])) ? $set['dbhost'] : $_REQUEST['dbhost'];
        $_REQUEST['prefix'] = (empty($_REQUEST['prefix'])) ? $set['prefix'] : $_REQUEST['prefix'];
        $_REQUEST['user_prefix'] = (empty($_REQUEST['user_prefix'])) ? $set['user_prefix'] : $_REQUEST['user_prefix'];
        $dbi = @mysql_connect($_REQUEST['dbhost'], $_REQUEST['dbuname'], $_REQUEST['dbpass']);
        if (!$dbi) {
            $err = '
            	<div class="warning">
            		<p>' . _NOT_CONNECT . '</p>
            		<p>' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . mysql_errno() . ')</p>
            	</div>';
        } else {
            if (empty($_REQUEST['dbname'])) {
                $err = '<p class="warning">' . _DBNOTSELECT . '</p>';
                $dbnotexist = true;
            } else if (!mysql_select_db($_REQUEST['dbname'] , $dbi)) {
                $errno = mysql_errno();
                if ($errno == 1046 || $errno == 1049) {
                    // DB existiert nicht oder unbekannt
                    $err = '
                    	<div class="warning">
                    		<p>' . _DBNOTEXIST . '</p>
                    		<p>' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . $errno . ')</p>
                    	</div>';
                    $dbnotexist = true;
                } else if ($errno == 1044 || $errno == 1045) {
                    // Zugriff auf DB/Server verweigert
                    $err = '
                    	<div class="warning">
                    		<p>' . _DBNOACCESS . '</p>
                    		<p>' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . $errno . ')</p>
                    	</div>';
                    $dbnotexist = false;
                } else {
                    // sonstige DB-Fehler
                    $err = '
                    	<div class="warning">
                    		<p>' . _DBOTHERERR . '</p>
                    		<p>' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . $errno . ')</p>
                    	</div>';
                    $dbnotexist = false;
                }
            }
            mysql_close();
        }

        if ($err) {
            $option = _STEP_DBSETTINGSCREATE;
            $output = $err;
            if ($dbnotexist && !empty($_REQUEST['dbname'])) {
                $output .= '
            			<p>' . _DBCREATEQUEST . '</p>
            			<form action="index.php" method="post" class="inline">
            				<p>' . hiddenrequest('setup') . '
            					<input type="submit" value="' . _NO . '" />
            				</p>
            			</form>
            			<form action="index.php" method="post" class="inline">
            				<p>' . hiddenrequest('createdb') . '
            					<input type="submit" value="' . _YES . '" />
            				</p>
            			</form>
            			<hr />
            			<h3>' . _OR . ':</h3>';
            }
            $output .= '
            	<p class="info">' . _CHECKSETTINGS . '</p>
        			<form action="index.php" method="post">
        				<p>' . hiddenrequest('checkdb') . '</p>
        				' . dbsettings($_REQUEST) . '
        				<p><input type="submit" value="' . _SUBMIT . '" /></p>
        			</form>';
        } else {
            $option = _STEP_MORESETTINGS;
            $output = '
        			<form action="index.php" method="post">
        			<p>' . hiddenrequest('viewsettings') . '</p>
        			<fieldset>
        			<legend>' . _PREFIXE . '</legend>
        				<ol>
        					<li>
        						<label for="prefix">' . _PREFIX . ':</label>
        						<input type="text" id="prefix" name="prefix" value="' . $set['prefix'] . '" size="25" />
        					</li>
        					<li>
        						<label for="user_prefix">' . _USERPREFIX . ':</label>
        						<input type="text" id="user_prefix" name="user_prefix" value="' . $set['user_prefix'] . '" size="25" />
        					</li>
        				</ol>
        				<p class="info">' . _PREFIXSETTING . '<br />' . _PRERR11 . '</p>
        			</fieldset>

        			<fieldset>
        			<legend>' . _SITE__MORESETTINGS . '</legend>
        	  		<ol>
        					<li>
        						<label for="defaultlang">' . _DEFAULTLANG . ':</label>
        						' . setupLanguageSelect('language', PATH_MX_LANGUAGE) . '
        					</li>
        					<li>
        						<label for="sitename">' . _SITENAME . ':</label>
        						<input type="text" id="sitename" name="sitename" value="' . $set['sitename'] . '" size="50" maxlength="100" />
        					</li>
        					<li>
        						<label for="stardate">' . _STARTDATE . ':</label>
        						<input type="text" id="stardate" name="startdate" value="' . $set['startdate'] . '" size="30" maxlength="30" />
        					</li>
        					<li>
        						<label for="adminmail">' . _ADMINEMAIL . ':</label>
        						<input type="text" id="adminmail" name="adminmail" value="' . $set['adminmail'] . '" size="30" maxlength="100" />
        					</li>
       						<li>
        						<label for="vkpIntranet">' . _INTRANETOPT . ':</label>
                		<input type="radio" id="vkpIntranet" name="vkpIntranet" value="0"' . ((empty($set['vkpIntranet'])) ? ' checked="checked"' : '') . ' />' . _NO . '
        	    			<input type="radio" name="vkpIntranet" value="1"' . ((empty($set['vkpIntranet'])) ? '' : ' checked="checked"') . ' />' . _YES . '
       						</li>
       					</ol>
          			<p class="info">' . _INTRANETWARNING . '</p>
        			</fieldset>
        			<p><input type="submit" value="' . _SUBMIT . '" /></p>
        			</form>';
        }
        break;
    /**
     */
    case 'viewsettings';
        $option = _STEP_MORESETTINGSCHECK;
        $errprefix = setupCheckNewPrefixes($_REQUEST['prefix'], $_REQUEST['user_prefix'], false);
        $prefixmsg = ($errprefix[0] != 'ok') ? '<p class="warning">' . $errprefix[1] . '</p>' : '';
        $output = '
        	<p class="info">' . _PLEASECHECKSETTINGS . '</p>
    			<ul class="checkbox">
    				<li>' . _DBSERVER . ': <strong>' . $_REQUEST['dbhost'] . '</strong></li>
    				<li>' . _DBNAME . ': <strong>' . $_REQUEST['dbname'] . '</strong></li>
    				<li>' . _DBUSERNAME . ': <strong>' . $_REQUEST['dbuname'] . '&nbsp;</strong></li>
    				<li>' . _DBPASS . ': <strong>' . $_REQUEST['dbpass'] . '&nbsp;</strong></li>
    				<li>' . _PREFIX . ': <strong>' . $_REQUEST['prefix'] . '</strong></li>
    				<li>' . _USERPREFIX . ': <strong>' . $_REQUEST['user_prefix'] . '</strong></li>
    				<li>' . _DEFAULTLANG . ': <strong>' . $_REQUEST['language'] . '</strong></li>
    				<li>' . _SITENAME . ': <strong>' . $_REQUEST['sitename'] . '</strong></li>
    				<li>' . _ADMINEMAIL . ': <strong>' . $_REQUEST['adminmail'] . '</strong></li>
    				<li>' . _STARTDATE . ': <strong>' . $_REQUEST['startdate'] . '</strong></li>
    				<li>' . _INTRANETOPT . ': <strong>' . ((empty($_REQUEST['vkpIntranet'])) ? _NO : _YES) . '</strong></li>
    			</ul>
    			' . $prefixmsg . '

    			<form action="index.php" method="post" class="inline">
    				<p>' . hiddenrequest('setup') . '
    					<input type="submit" value="' . _CORRECTION . '" />&nbsp;&nbsp;
    				</p>
    			</form>';

        if ($errprefix[0] != 'critical') {
            $capt = ($errprefix[0] == 'check') ? _IGNORE : _SUBMIT;
            $output .= '
        			<form action="index.php" method="post" class="inline">
        				<p>' . hiddenrequest('savesettings') . '
        					<input type="submit" value="' . $capt . '" />
        				</p>
        			</form>';
        }

        break;
    /**
     */
    case 'createdb';
        $ok = false;
        $dbi = @mysql_connect($_REQUEST['dbhost'], $_REQUEST['dbuname'], $_REQUEST['dbpass']);
        if (!$dbi) {
            $msg = _NOT_CONNECT . '<br />' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . mysql_errno() . ')';
        } else {
            if (mysql_query('CREATE DATABASE `' . $_REQUEST['dbname'] . '`;', $dbi)) {
                $msg = _DBISCREATED;
                $ok = true;
            } else {
                $msg = _DBNOTCREATED . '<br />' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . mysql_errno() . ')';
            }
        }
        if ($ok) {
            $option = _STEP_DBSETTINGS;
            $output = '
            	<p><strong>' . $msg . '</strong></p>
        			<form action="index.php" method="post" class="inline">
        				<p>' . hiddenrequest('checkdb') . '
        					<input type="submit" value="' . _SUBMIT . '" />
        				</p>
        			</form>';
        } else {
            $option = _STEP_DBSETTINGSCREATE;
            $output = '
            	<p class="warning">' . $msg . '</p>
        			<form action="index.php" method="post" class="inline">
        				<p>' . hiddenrequest('checkdb') . '</p>
        				' . dbsettings($_REQUEST) . '
        				<p><input type="submit" value="' . _SUBMIT . '" /></p>
        			</form>';
        }
        break;
    /**
     */
    case 'savesettings';
        $option = _CURRENTSTATUS;
        require('includes/function_saveconfigfile.php');
        $status = SetupSaveConfigFile($_POST);
        // mxDebugFuncVars($status); exit;
        if ($status['ok']) {
            include(FILE_CONFIG_ROOT);
            $tablecount = 0;
            $mxcount = 0;
            $mxusercount = 0;
            $dbstat = setupConnectDb();
            if (isset($dbstat['dbi'])) {
                $result = mysql_query("SHOW TABLES FROM `" . $dbname . "");
                if ($result) {
                    while ($table = mysql_fetch_row($result)) {
                        preg_match('#^(' . $user_prefix . '_users)|^(' . $prefix . '_)#i', $table[0], $matches);
                        $tablecount++;
                        // mxDebugFuncVars($matches);
                        if (!empty($matches[1])) $mxusercount++;
                        else if (!empty($matches[2])) $mxcount++;
                    }
                    // mxDebugFuncVars($tablecount, $mxcount, $mxusercount);
                }
            }
            if ($mxcount) {
                $dbmsg = sprintf(_PRERR17, $mxcount);
                $errprefix = true;
            } else if ($tablecount) {
                // backup checken
                require('includes/function_dbbackup.php');
                $backup_available = setup_dbbackup('only_check');
                if ($backup_available) {
                    $domsg = '
                    	<p>' . _WILL_CREATE_TABLES . '</p>
                    	<p>' . _WILL_CREATE_BACKUP . '</p>';
                } else {
                    $domsg = '
                    	<p>' . _WILL_CREATE_TABLES . '</p>
                    	<p>' . _BACKUPBESHURE . '</p>';
                }
                $dbmsg = _DBARETABLES;
            } else {
                $dbmsg = _DBARENOTABLES;
                $domsg = '<p>' . _WILL_CREATE_TABLES . '</p>';
            }

            if (isset($errprefix)) {
                $output = '
                	<p><strong>' . $dbmsg . '</strong></p>
            			<form action="index.php" method="post">
            				<p>' . hiddenrequest('setup') . '
            					<input type="submit" value="' . _CORRECTION . '" />
            				</p>
            			</form>';
            } else {
                $output = '
            			<div class="info">
            				<ul>' . $status['msg'] . ' ' . $dbmsg . '</ul>
            			</div>
            			<hr />
            			' . $domsg . '

            			<form action="index.php" method="post" class="inline">
            				<p>' . hiddenrequest('setup') . '
            					<input type="submit" value="' . _CORRECTION . '" />&nbsp;&nbsp;
            				</p>
            			</form>';

                if ($tablecount) {
                    if ($backup_available) {
                        $output .= '
                    	<form action="index.php" method="post" class="inline">
                				<p>' . hiddenrequest('dbup') . '
                					<input type="hidden" name="createbackup" value="1" />
                					<input type="submit" value="' . _CONTINUE_WITHDBBACKUP . '" />
                				</p>
                			</form>
                			<form action="index.php" method="post" class="inline">
                				<p>' . hiddenrequest('dbup') . '
                					<input type="hidden" name="createbackup" value="0" />
                					<input type="submit" value="' . _CONTINUE_WITHOUTDBBACKUP . '" />&nbsp;&nbsp;
                				</p>
                			</form>';
                    } else {
                        $output .= '
            			<form action="index.php" method="post" class="inline">
            				<p>' . hiddenrequest('dbup') . '
            					<input type="hidden" name="cantbackup" value="0" />
            					<input type="submit" value="' . _SUBMIT . '" />&nbsp;&nbsp;&nbsp;
                                <input type="checkbox" name="beshure" value="1" title="' . _BACKUPBESHUREOK . '" />
                                &nbsp;' . _BACKUPBESHUREYES . '
            				</p>
            			</form>
            			';
                    }
                } else {
                    $output .= '
                			<form action="index.php" method="post" class="inline">
                				<p>' . hiddenrequest('dbup') . '
                					<input type="hidden" name="createbackup" value="0" />
                					<input type="submit" value="' . _SUBMIT . '" />&nbsp;&nbsp;
                				</p>
                			</form>';
                }
                $output .= '';
            }
        } else {
            $output = '
            <p><strong>' . _THEREERROR . '</strong></p>
            <div class="info">
            	<ul>' . $status['msg'] . '</ul>
            </div>

        		<form action="index.php" method="post" class="inline">
        			<p>' . hiddenrequest('setup') . '
        				<input type="submit" value="' . _CORRECTION . '" />&nbsp;&nbsp;
        			</p>
        		</form>
        		<form action="index.php" method="post" class="inline">
        			<p>' . hiddenrequest('showconfig') . '
        				<input type="hidden" name="configphp" value="' . $status['configphp'] . '" />
        				<input type="submit" value="' . _CONFIG_BUTTONMAN . '" />&nbsp;&nbsp;
        			</p>
        		</form>';
        }
        break;
    /**
     */
    case 'showconfig';
        $option = _CONFIG_BUTTONMAN;
        $output = '
    			<p>' . _CONFIG_CREATE . '</p>
    			<p><textarea cols="80" rows="25" name="xxconfigphp">' . $_REQUEST['configphp'] . '</textarea></p>
    			<form action="index.php" method="post" class="inline">
    				<p>' . hiddenrequest($_REQUEST['lastop']) . '
    					<input type="submit" value="' . _GOBACK . '" />
    				</p>
    			</form>
    			<form action="index.php" method="post" class="inline">
    				<p>' . hiddenrequest('savesettings') . '
    					<input type="submit" value="' . _SUBMIT . '" />
    				</p>
    			</form>';
        break;
    /**
     */
    case 'dbup';
        $createbackup = (empty($_POST['createbackup'])) ? 0 : 1;
        if ($createbackup) {
            require('includes/function_dbbackup.php');
            $backup = setup_dbbackup();
        } else {
            if (isset($_POST['cantbackup'])) {
                // nicht bestaetigt
                if (empty($_POST['beshure'])) {
                    $option = _STEP_BACKUP;
                    $output .= '<p>' . _BACKUPBESHURE . '</p>
                <br /><p class="warning">' . _BACKUPBESHUREOK . '</p><br />
    			<form action="index.php" method="post" class="inline">
    				<p>' . hiddenrequest('setup') . '
    					<input type="submit" value="' . _CORRECTION . '" />
    				</p>
    			</form>
    			<form action="index.php" method="post" class="inline">
    				<p>' . hiddenrequest('dbup') . '
    					<input type="hidden" name="cantbackup" value="0" />
    					<input type="submit" value="' . _SUBMIT . '" />&nbsp;&nbsp;&nbsp;
                        <input type="checkbox" name="beshure" value="1" title="' . _BACKUPBESHUREOK . '" />
                        &nbsp;' . _BACKUPBESHUREYES . '
    				</p>
    			</form>
    			';
                    break;
                } else {
                    $backup['stat'] = 3;
                }
            } else {
                $backup['stat'] = 2;
                $backup['msg'] = _NOBACKUPCREATED;
            }
        }
        // mxDebugFuncVars($backup);
        if (empty($backup['stat'])) {
            $option = _STEP_BACKUP_NEW;
            $output .= $backup['msg'] . '<br /><br />
        			<form action="index.php" method="post">
        				<p>' . hiddenrequest('dbup') . '
        					<input type="hidden" name="createbackup" value="0" />
        					<input type="submit" value="' . _SUBMIT . '" />
        				</p>
        			</form>';
        } else {
            $dbstat = setupConnectDb();
            if (!isset($dbstat['dbi'])) {
                // uups, da ist was falsch
                $option = _STEP_UPDATE;
                $msg = (isset($dbstat['msg'])) ? $dbstat['msg'] : _NOT_CONNECT;
                $output .= '
                	<br /><br />
            			<p>' . $msg . '</p><br />
            			<form action="index.php" method="post">
            				<p>' . hiddenrequest('setup') . '
            					<input type="submit" value="' . _CORRECTION . '" />
            				</p>
            			</form>';
            } else {
                $option = _CURRENTSTATUS;
                require('includes/function_dbupgrade.php');
                $querystat = setup_dbupgrade($dbstat['dbi']);
                // Nachricht von Backupfunktion hinzufuegen
                if (isset($backup['msg'])) {
                    $querystat['msg'][] = $backup['msg'];
                }
                // mxDebugFuncVars($querystat);
                $output .= '
                	<div class="info">
                		<ul>
                			<li>' . (implode('</li><li>', $querystat['msg'])) . '</li>
                		</ul>
                	</div>';
                // Statusanzeige
                switch ($querystat['status']) {
                    case 'critical':
                        $output .= '<p class="warning">' . _HAVECREATE_TABLES_ERR . '</p>';
                        $querystat['count_err'] = count($querystat['msg_err']);
                        break;
                    case 'check':
                        $output .= '<p class="warning">' . _HAVE_CREATE_TABLES_7 . '</p>';
                        break;
                    default:
                        $output .= '<p><strong>' . _DB_UPDATEREADY . '</strong></p>';
                }
                // wenn Fehler aufgetreten, diese Anzeigen
                if ($querystat['count_err']) {
                    $output .= '
                    	<div class="warning">
                    		<p>' . _DBFOLLOWERRORS . ':</p>
                				<textarea cols="80" rows="4" name="log_err" class="status">' . htmlspecialchars(trim(str_replace("\n\n", "\n", $querystat['msg_err']))) . '</textarea>';
                    if (@is_file(FILE_LOG_ERR)) {
                        $output .= '<p>' . _SEEALL . ': <a href="logview.php?file=' . FILE_LOG_ERR . '" target="_blank">' . str_replace(MX_SETUP_DIR, '', FILE_LOG_ERR) . '</a></p>';
                    }
                    $output .= '
                    	</div>';
                }

                $output .= '
            			<form action="index.php" method="post" class="inline">
            				<p>' . hiddenrequest('setup') . '
            					<input type="submit" value="' . _GOBACK . '" />
            				</p>
            			</form>';
                if ($querystat['status'] != 'ok') {
                    // wenn Fehler aufgetreten oder setup gescheitert, wiederholen anbieten
                    $output .= '
                    	<form action="index.php" method="post" class="inline">
                				<p>' . hiddenrequest('dbup') . '
                					<input type="hidden" name="createbackup" value="' . $createbackup . '" />
                					<input type="submit" value="' . _REMAKE . '" />
                				</p>
                			</form>';
                }
                if ($querystat['status'] != 'critical') {
                    // wenn setup erfolgreich oder auch mit kleinen Fehlern > ignorieren/weiter mit nextop
                    // standardmssig wird als nchstes ein Admin erstellt
                    $capt = ($querystat['status'] == 'check') ? _IGNORE : _SUBMIT;
                    $output .= '
                    	<form action="index.php" method="post" class="inline">
                				<p>' . hiddenrequest('createadmin') . '
                					<input type="submit" value="' . $capt . '" />
                				</p>
                			</form>';
                }
                if ($querystat['count_ok']) {
                    // wenn erfolgreiche Datenbanknderungen stattgefunden haben
                    $output .= '
                    	<div class="info">
                    		<p>' . _GET_SQLHINTS . ':</p>
                		<textarea cols="80" rows="4" name="log_ok" class="status">' . htmlspecialchars(trim(str_replace("\n\n", "\n", $querystat['msg_ok']))) . '</textarea>';
                    if (@is_file(FILE_LOG_OK)) {
                        $output .= '<p>' . _SEEALL . ': <a href="logview.php?file=' . FILE_LOG_OK . '" target="_blank">' . str_replace(MX_SETUP_DIR, '', FILE_LOG_OK) . '</a></p>';
                    }
                    $output .= '
                    	</div>';
                }
            }
        }
        break;
    /**
     */
    case 'createadmin';
        $option = _STEP_CREATEADMIN;
        mxSetupSetHomeDir();
        $output .= '
        	<form action="index.php" method="post">
    				' . createadminform() . '
    				<p>' . hiddenrequest('createadmindoit') . '
    					<input type="submit" value="' . _DOCREATEADMIN . '" />
    				</p>
    			</form>
    			<hr />
    			<p><strong>' . _ERRNOADMINCONNECT . '</strong></p>
    			<form action="index.php" method="post">
    				<p>' . hiddenrequest('finish') . '
    					<input type="submit" value="' . _SUBMIT . '" />
    				</p>
    			</form>';
        break;
    /**
     */
    case 'createadmindoit';
        $err = false;
        if (empty($_POST['first_name']) || empty($_POST['first_pwd']) || empty($_POST['first_email'])) {
            $option = _STEP_CREATEADMIN;
            mxSetupSetHomeDir();
            $output .= '
            	<p class="warning">' . _ERRNOADMINDATA . '</p>
        			<form action="index.php" method="post">
        				' . createadminform() . '
        				<p>' . hiddenrequest('createadmindoit') . '
        					<input type="submit" value="' . _DOCREATEADMIN . '" />
        				</p>
        			</form>
        			<hr />
        			<p><strong>' . _ERRNOADMINCONNECT . '</strong></p>
        			<form action="index.php" method="post">
        				<p>' . hiddenrequest('finish') . '
        					<input type="submit" value="' . _SUBMIT . '" />
        				</p>
        			</form>';
        } else {
            include(FILE_CONFIG_ROOT);
            $dbstat = setupConnectDb();
            if (isset($dbstat['dbi'])) {
                $qry = "SELECT uid, uname, name, email, url, user_regdate, user_regtime, user_stat FROM ${user_prefix}_users WHERE uname='" . $_POST['first_name'] . "'";
                $result = mysql_query($qry);
                $row = mysql_fetch_assoc($result);
                if (intval($row['uid'])) {
                    $uid = intval($row['uid']);
                    $set[] = "user_stat='1'";
                    $set[] = "pass='" . md5($_POST['first_pwd']) . "'";
                    if (empty($row['email'])) {
                        $set[] = "email='" . $_POST['first_email'] . "'";
                    }
                    if (empty($row['url'])) {
                        $set[] = "url='" . $_POST['first_url'] . "'";
                    }
                    $qry = "UPDATE `${user_prefix}_users` SET " . implode(',', $set) . " WHERE uid='" . $uid . "'";
                } else {
                    // Laendereinstellung, auf Englisch setzen
                    $old_setlocale = setlocale(LC_TIME, 0);
                    setlocale(LC_TIME, 'en_EN');
                    $user_regdate = date("M d, Y", time());
                    // Laendereinstellung, mit den Werten aus dem globalen Sprachfile zuruecksetzen
                    setlocale(LC_TIME, $old_setlocale);
                    $result = mysql_query("SELECT MAX(uid) FROM ${user_prefix}_users");
                    list($uid) = mysql_fetch_row($result);
                    $uid = intval($uid) + 1;
                    $qry = "REPLACE INTO `${user_prefix}_users` SET
                        uid='" . $uid . "',
                        uname='" . $_POST['first_name'] . "',
                        name='" . $_POST['first_name'] . "',
                        email='" . $_POST['first_email'] . "',
                        url='" . $_POST['first_url'] . "',
                        pass='" . md5($_POST['first_pwd']) . "',
                        user_regdate='" . $user_regdate . "',
                        user_regtime='" . time() . "',
                        user_stat='1'";
                }
                $result = mysql_query($qry);
                // $qry = "INSERT INTO `${user_prefix}_sys_groups_user` ( `grp_id` , `uid` ) VALUES ('" . SYS_GROUP_ID_SUPERADMIN . "', '" . $uid . "')";
                // $result = mysql_query($qry);
                // if (!$result) {
                // $err = true;
                // $msg = _ADMINCREATEDERR;
                // } else {
                $qry = "REPLACE INTO ${prefix}_authors SET name='God', aid='" . $_POST['first_name'] . "', email='" . $_POST['first_email'] . "', url='" . $_POST['first_url'] . "', pwd='" . md5($_POST['first_pwd']) . "', radminsuper='1', user_uid='" . $uid . "'";
                mysql_query($qry);
                // }
            } else {
                // uups, da ist was falsch
                $msg = _NOT_CONNECT;
                $err = true;
            }
            if ($err) {
                $msg = '<p class="warning">' . $msg . '</p><br /><br />' . _ERRNOADMINCONNECT;
            } else {
                $msg = _ADMINCREATED;
            }
            $option = _STEP_FINISHEDINSTALL;
            $output .= '
            	<p>' . $msg . '</p>
        			<h3>' . _SETUPHAPPY1 . '</h3>
        			<p>' . _SETUPHAPPY2 . '</p>
           		    <div class="warning">' . _DELETE_FILES . '
                		' . printdeleter() . '
                	</div>
        			<form action="' . PATH_MX_BASE . '/admin.php?op=Configure" class="inline">
        				<p>
        					<input type="hidden" name="op" value="Configure" />
        					<input type="submit" value="' . _GOTOADMIN . '" />
        				</p>
        			</form>
        			<hr />
        			<ul>
        				<li>' . _SUPPORTINFO . '</li>
        				<li>' . _DOKUINFO . '</li>
        			</ul>';
        }
        break;
    /**
     */
    case 'finish';
        $option = _STEP_FINISHEDINSTALL;
        $output .= '
        	<h3>' . _SETUPHAPPY1 . '</h3>
        	<p>' . _SETUPHAPPY2 . '</p>
        	<div class="warning">' . _DELETE_FILES . '
        		' . printdeleter() . '
        	</div>
        	<form action="' . PATH_MX_BASE . '/admin.php?op=Configure" class="inline">
        		<p>
        			<input type="hidden" name="op" value="Configure" />
        			<input type="submit" value="' . _GOTOADMIN . '" />
        		</p>
        	</form>
        	<hr />
        	<ul>
        		<li>' . _SUPPORTINFO . '</li>
        		<li>' . _DOKUINFO . '</li>
        	</ul>';
        break;
        // end case
}

?>